+2014-03-14 Joseph Myers <joseph@codesourcery.com>
+
+ * scripts/evaluate-test.sh: Handle fourth argument to determine
+ whether test run should stop on failure.
+ * Makeconfig (stop-on-test-failure): New variable.
+ (evaluate-test): Pass fourth argument to evaluate-test.sh based on
+ $(stop-on-test-failure).
+ * Makefile (tests): Give a summary of results from testing and
+ exit with failure status if they include an ERROR or FAIL.
+ (xtests): Likewise.
+ * manual/install.texi (Configuring and compiling): Mention
+ stop-on-test-failure=y.
+ * INSTALL: Regenerated.
+
2014-03-14 Roland McGrath <roland@hack.frob.com>
* scripts/versionlist.awk: New file.
system such as `/etc/passwd', `/etc/nsswitch.conf' and others. These
files must all contain correct and sensible content.
+ Normally, `make check' will run all the tests before reporting all
+problems found and exiting with error status if any problems occurred.
+You can specify `stop-on-test-failure=y' when running `make check' to
+make the test run stop and exit with an error status immediately when a
+failure occurs.
+
To format the `GNU C Library Reference Manual' for printing, type
`make dvi'. You need a working TeX installation to do this. The
distribution builds the on-line formatted version of the manual, as
endif
endif
+# Whether to stop immediately when a test fails. Nonempty means to
+# stop, empty means not to stop.
+ifndef stop-on-test-failure
+stop-on-test-failure =
+endif
+
# How to run a program we just linked with our library.
# The program binary is assumed to be $(word 2,$^).
built-program-file = $(dir $(word 2,$^))$(notdir $(word 2,$^))
# XPASS or XFAIL rather than PASS or FAIL.
evaluate-test = $(..)scripts/evaluate-test.sh $(test-name) $$? \
$(if $(test-xfail-$(test-xfail-name)),true,false) \
+ $(if $(stop-on-test-failure),true,false) \
> $(common-objpfx)$(test-name).test-result
endif # Makeconfig not yet included
$(..)scripts/merge-test-results.sh -t $(objpfx) subdir-tests.sum \
$(sort $(subdirs) .) \
> $(objpfx)tests.sum
+ @grep '^ERROR:' $(objpfx)tests.sum || true
+ @grep '^FAIL:' $(objpfx)tests.sum || true
+ @echo "Summary of test results:"
+ @sed 's/:.*//' < $(objpfx)tests.sum | sort | uniq -c
+ @if grep -q '^ERROR:' $(objpfx)tests.sum; then exit 1; fi
+ @if grep -q '^FAIL:' $(objpfx)tests.sum; then exit 1; fi
xtests:
$(..)scripts/merge-test-results.sh -t $(objpfx) subdir-xtests.sum \
$(sort $(subdirs)) \
> $(objpfx)xtests.sum
+ @grep '^ERROR:' $(objpfx)xtests.sum || true
+ @grep '^FAIL:' $(objpfx)xtests.sum || true
+ @echo "Summary of test results for extra tests:"
+ @sed 's/:.*//' < $(objpfx)xtests.sum | sort | uniq -c
+ @if grep -q '^ERROR:' $(objpfx)xtests.sum; then exit 1; fi
+ @if grep -q '^FAIL:' $(objpfx)xtests.sum; then exit 1; fi
# The realclean target is just like distclean for the parent, but we want
# the subdirs to know the difference in case they care.
16611, 16613, 16623, 16632, 16639, 16642, 16670, 16674, 16677, 16683,
16689, 16695, 16701, 16706, 16707.
+* Running the testsuite no longer terminates as soon as a test fails.
+ Instead, a file tests.sum (xtests.sum from "make xcheck") is generated,
+ with PASS or FAIL lines for individual tests. A summary of the results is
+ printed, including a list of failing lists, and "make check" exits with
+ error status if there were any unexpected failures. "make check
+ stop-on-test-failure=y" may be used to keep the old behavior.
+
* The am33 port, which had not worked for several years, has been removed
from ports.
system such as @file{/etc/passwd}, @file{/etc/nsswitch.conf} and others.
These files must all contain correct and sensible content.
+Normally, @code{make check} will run all the tests before reporting
+all problems found and exiting with error status if any problems
+occurred. You can specify @samp{stop-on-test-failure=y} when running
+@code{make check} to make the test run stop and exit with an error
+status immediately when a failure occurs.
+
To format the @cite{GNU C Library Reference Manual} for printing, type
@w{@code{make dvi}}. You need a working @TeX{} installation to do
this. The distribution builds the on-line formatted version of the
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.
-# usage: evaluate-test.sh test_name rc xfail
+# usage: evaluate-test.sh test_name rc xfail stop_on_failure
test_name=$1
rc=$2
orig_rc=$rc
xfail=$3
+stop_on_failure=$4
if [ $rc -eq 0 ]; then
result="PASS"
echo "$result: $test_name"
echo "original exit status $orig_rc"
-exit $rc
+if $stop_on_failure; then
+ exit $rc
+else
+ exit 0
+fi